#include "sockutil.c"
#include <string.h>	/* strerror */
#include <signal.h>

#define PORT "9200"
#define REQ_LENGTH 32
#define MAX_WAIT_TIME 4

static void alarm_catcher(int sig)
{
}


int main(int argc, char *argv[])
{
	int sock, n;
	char buf[REQ_LENGTH];
	struct sigaction act;

	sock = open_tcpsock_as_client("localhost", PORT);
	if(sock < 0) {
		fprintf(stderr, "error: can't establish connection\n");
		return 1;
	}

	/* 顼ॷʥΥϥɥ
	 * ˺ȡSIGALRMΥǥեưȤ
	 * ץλƤޤ*/

	/* ܿ: C饤֥ˤäƤϡsignal(3C)
	 * SIGARLMϥɥꤷƤ⡢readƥॳ뤬Ǥʤ
	 * (줬BSDߴưǤ餷)
	 * ޤǤϡΤ褦sa_flags
	 * SA_RESTARTꤻsigaction(2)Ȥȡ
	 */
	sigemptyset(&act.sa_mask);
	act.sa_handler = alarm_catcher;
	act.sa_flags = 0;
	sigaction(SIGALRM, &act, NULL);

	/* ɤߤ롼 */
	for(;;) {
		alarm(MAX_WAIT_TIME);
		n = read(sock, buf, sizeof(buf));
		alarm(0);

		if(n == 0) {
			/* եν */
			break;
		} else if(n < 0) {
			/* 顼 */
			fprintf(stderr,
				"read() failed: code=%d, errno=%d, reason=%s\n",
				n, errno, strerror(errno));
			break;
		} else if(n > 0) {
			/* ɤ߹᤿ */
			fprintf(stderr, "%d bytes recieved, message was: %.*s\n",
				n, n, buf);
		}
	}
	return 0;
}
