#include "sockutil.c"

#define PORT "9200"

static void wait_animation(void)
{
	static int idx;
	fprintf(stderr, "waiting %c\r", "|/-\\"[idx++ % 4]);
}

int main(int argc, char *argv[])
{
	int sock, n;
	char buf[32];

	sock = open_tcpsock_as_client("localhost", PORT);
	if(sock < 0) {
		fprintf(stderr, "error: can't establish connection\n");
		return 1;
	}

	for(;;) {
		if(poll_readable(sock) > 0) {
			/* ɤߤǽʤȤν */
			n = read(sock, buf, sizeof(buf));
			if(n == 0) break; /* EOF */

			fprintf(stderr, "%d bytes recieved, message was: %.*s\n",
				n, n, buf);

		} else {
			/* ɤߤǽǤʤȤν */
			wait_animation();
			usleep(1000 * 200);
		}
	}
	return 0;
}
