#include "sockutil.c"
#include <string.h>	/* strerror */

#define PORT "9200"

static void wait_animation(void)
{
	static int idx;
	fprintf(stderr, "waiting %c\r", "|/-\\"[idx++ % 4]);
}

int main(int argc, char *argv[])
{
	int sock, n;
	char buf[32];

	sock = open_tcpsock_as_client("localhost", PORT);
	if(sock < 0) {
		fprintf(stderr, "error: can't establish connection\n");
		return 1;
	}

	set_nonblocking_mode(sock);

	for(;;) {
		n = read(sock, buf, sizeof(buf));

		if(n == 0) break; /* EOF */

		if(n < 0) {
			if(errno == EAGAIN) {
				/* ɤߤǽǤʤȤν */
				wait_animation();
				usleep(1000 * 200);
				continue;
			} else {
				/* 顼ΤȤ */
				fprintf(stderr, "read() failed: code=%d, errno=%d, reason=%s\n",
					n, errno, strerror(errno));
				break;
			}
		}

		/* ɤ߹᤿ */
		fprintf(stderr, "%d bytes recieved, message was: %.*s\n",
				n, n, buf);
	}
	return 0;
}
